<template>
  <q-dialog ref="dialogRef" @hide="onDialogHide">
    <q-card
      class="q-dialog-plugin"
      style="width: 360px; max-width: 100%; padding: 0; background: #1e1e1e"
      flat
    >
      <q-card-section class="text-center" style="padding: 15px">
        <img src="/misc/cashconnect-logo.svg" style="height: 50px" />
        <div class="text-center text-uppercase light cc-subheading">
          Powered by Wallet Connect
        </div>
      </q-card-section>
      <q-card-section>
        <div class="text-center text-weight-bold text-uppercase light">
          Connect your wallet
        </div>
      </q-card-section>
      <q-card-section class="q-mx-lg" style="padding: 0">
        <!-- Docs for this here: https://qr.bitjson.com/ -->
        <qr-code
          :contents="props.url"
          module-color="#000"
          position-ring-color="#30e483"
          position-center-color="#000"
          style="width: 100%; background-color: #fff"
        >
          <!-- There's also cashrpc-icon-white.svg -->
          <img
            src="/misc/cashrpc-icon-white.svg"
            slot="icon"
            style="width: 100%; height: 100%"
          />
        </qr-code>
      </q-card-section>
      <q-card-section style="padding: 0">
        <div class="row">
          <div class="col">
            <q-btn
              flat
              class="q-py-md light"
              type="a"
              label="Open in Cashonize"
              icon="img:https://cashonize.com/images/cashonize-icon.png"
              :href="encodeCashonizeUrl()"
              target="_blank"
            />
          </div>
          <div class="col">
            <q-btn
              flat
              class="q-py-md light"
              label="Copy to Clipboard"
              icon="copy"
              @click="onCopyToClipboard(props.url)"
            />
          </div>
        </div>
      </q-card-section>
    </q-card>
  </q-dialog>
</template>

<script lang="ts" setup>
import { useDialogPluginComponent, useQuasar, copyToClipboard } from 'quasar';

const $q = useQuasar();

const props = withDefaults(
  defineProps<{
    url: string;
  }>(),
  {
    url: '',
  }
);

defineEmits([
  // REQUIRED; need to specify some events that your
  // component will emit through useDialogPluginComponent()
  ...useDialogPluginComponent.emits,
]);

const { dialogRef, onDialogHide, onDialogOK, onDialogCancel } =
  useDialogPluginComponent();
// dialogRef      - Vue ref to be applied to QDialog
// onDialogHide   - Function to be used as handler for @hide on QDialog
// onDialogOK     - Function to call to settle dialog with "ok" outcome
//                    example: onDialogOK() - no payload
//                    example: onDialogOK({ /*...*/ }) - with payload
// onDialogCancel - Function to call to settle dialog with "cancel" outcome

function encodeCashonizeUrl() {
  const cashonizeBaseUrl = 'https://frolicking-pothos-d1aefc.netlify.app';
  const walletConnectUrl = encodeURIComponent(props.url);

  return `${cashonizeBaseUrl}/#/?uri=${walletConnectUrl}`;
}

function onCopyToClipboard(url: string) {
  copyToClipboard(url);

  $q.notify({
    message: 'CashConnect URL copied to clipboard',
    color: 'positive',
  });
}
</script>
